Anura Reporting API
The Anura Reporting API is the most advanced method to access report data from Anura Script and Anura Direct outside of our dashboard. With the Anura Reporting API, you can:
Build custom reports with the metrics you want to know more about.
Automate complex analysis.
Integrate or layer Anura Reporting data in conjunction with other reporting or backend data.
Anura Reporting API - Integration
The Anura Reporting API allows you to access Anura reports data from within your own applications. To get started, you will need to create a reporting API token.
Anura Reporting API - Integration - API Tokens
You can create and manage Reporting API tokens by logging into the Anura Dashboard and going to the "Reporting API" token management interface, located within the "Account" section of the navigation menu, or by visiting https://dashboard.anura.io/api .
Create Reporting API Token Form Fields
Field
Description
Note
Token Name
A unique identifying name for the Reporting API token.
Required.
Limit Instance
Limits the Reporting API to return data for the selected instance(s) only.
Data will be returned for all instances associated with your Anura user account when no specification is made.
Authorized IP Address
Limits the Reporting API to return data for the specified IP address(es) only.
Both IPv4 and IPv6 addresses are supported. Private and reserved IP addresses are not allowed.
Token Expires
Sets the token to expire on a specified date.
Reporting API tokens expire at 12:00 AM Coordinated Universal Time (UTC) on their specified date and will be removed from our database after 30 days. Reporting API tokens that do not have an expiration will otherwise never expire.
Managing Reporting API Tokens
Reporting API tokens may be temporarily enabled or disabled.
Reporting API tokens may be permanently removed.
As of June 06, 2019, Reporting API tokens are bound to the user account that created them. If the creating user's account is disabled, all of their corresponding tokens will also be disabled.
Anura Reporting API - Integration - Performing Requests
Requests to the Anura Reporting API are made over secure connections using the HTTP POST method.
Things to Remember...
POST parameter string values must be URL encoded.
Drilling into metric reporting data will require optional parameters to be set.
Some drilldown parameters require that a parent parameter be applied first.
A daily breakdown will be returned when all applicable drilldown parameters have been applied.
Instance, source, and campaign interface parameters may be applied at any time.
"All Instances", "All Sources", and "All Campaigns" are acceptable interface values where applicable.
Anura reporting is based on the Coordinated Universal Time (UTC) time zone.
Limitations
Date specific API requests are limited to a 7-day rolling time frame with the exception of "Overview" endpoints, which have a 31-day rolling time frame. If your request falls outside of the time frame limit, a HTTP status code of "400 - Bad Request" will be returned. See Reporting API: Handling Responses for more details.
Anura Reporting API - Integration - Handling Responses
Responses from the Anura Reporting API are JSON encoded and typically returned within milliseconds. However, in cases where vast amounts of unique data exist, responses may take several seconds or minutes. Please be sure to adjust any timeouts to wait until the response has been returned.
There are 5 distinct HTTP status response codes that may be encountered when performing requests. The following table provides HTTP status codes with a brief description of their meaning:
Status Code
Description
200 - OK
The request was successful and a response was returned.
400 - Bad Request
There was a problem with your request parameters. Please be sure you have passed a complete and valid token string and that your request falls within the allowed rolling time frame.
401 - Unauthorized
Your token is not authorized to access the requested resource.
403 - Forbidden
Your token does not have permission to access the requested resource.
404 - Not Found
The resource you are looking for was not found. Please check the endpoint address and try again.
Things to Remember...
String response values are returned URL encoded.
Script and Direct "instance" table values are returned as a URL encoded object containing both the "id" and "name" of the instance.
Script's "adblocker" value may return "null" when ad blocker detection is not enabled for your instance.
Anura Reporting API - Integration - Summary Filters
Summary filters enable the further refinement of Anura Reporting API data, allowing only results that match the provided constraints to be returned.
Filter Groups and Filter Objects
Summary filters are structured as an array of one or more "filter group" arrays containing "filter objects."
Filter objects are used to provide constraints for your query, each defining their own column, operator, and value.
Filter groups allow for multiple sets of constraints to be applied at the same time.
Filter groups are combined using OR statements while each filter object in the group is combined using AND statements.
For example, if you want to return only sources from a Script sessions endpoint having greater than 5,000 requests, you can create a single filter group array containing one filter object.
JSON Copy
[
[
{
"column": "requests",
"operator": "greater_than",
"value": 5000
}
]
]
Equivalent SQL
WHERE (requests > 5000)
To further the example, of the sources returned, you want to view only sources whose rate of good traffic is less than or equal to 30%. In this case, you would create a single filter group array containing two filter objects.
JSON Copy
[
[
{
"column": "requests",
"operator": "greater_than",
"value": 5000
},
{
"column": "good_rate",
"operator": "less_than_equal_to",
"value": 30.00
}
]
]
Equivalent SQL
WHERE (requests > 5000 AND good_rate <= 30.00)
To go even further, you also want to include sources having greater than 2,000 responses whose warning rate is greater than or equal to 80%. To accomplish this, you would create two filter groups, each containing two filter objects.
JSON Copy
[
[
{
"column": "requests",
"operator": "greater_than",
"value": 5000
},
{
"column": "good_rate",
"operator": "less_than_equal_to",
"value": 30.00
}
],
[
{
"column": "responses",
"operator": "greater_than",
"value": 2000
},
{
"column": "warning_rate",
"operator": "greater_than_equal_to",
"value": 80.00
}
]
]
Equivalent SQL
WHERE (requests > 5000 AND good_rate <= 30.00) OR (responses > 2000 AND warning_rate >= 80.00)
There are no restrictions to the number of filter groups or filter objects you can use to filter your summary data. However, be mindful not to apply too many constraints as the result set may be reduced in an undesirable manner.
Applying Summary Filters
Summary filters can be applied by passing a pre-saved filter ID, or an "on the fly" array of filter objects, to Script endpoints and Direct endpoints using the filters POST parameter.
All tabular Script and Direct summary data returned by the Anura Reporting API can be filtered. However, there are a few things to be aware of...
The first column in a summary data table is a string referred to as the "primary key".
Rate columns and Rule Set columns will always be returned when filtered, regardless of display preference.
Columns not available for specific reporting endpoints will be ignored, while also having a conflict message returned.
Script Columns
The following columns can be used when filtering Script summary data.
Column
Type
Note
primary_key
string
The first column returned in a table of summary data. All data in the table is grouped by this primary key.
requests
integer
Not available for languages, pages, or referrers endpoints.
responses
integer
drop_rate
float
Not available for languages, pages, or referrers endpoints.
good
integer
good_rate
float
warning
integer
warning_rate
float
bad
integer
bad_rate
float
mobile
integer
mobile_rate
float
adblocker
integer
adblocker_rate
float
data_integrity
integer
user_environment
integer
data_center
integer
traffic_origin
integer
ip_integrity
integer
spoofing
integer
web_crawler
integer
Direct Columns
The following columns can be used when filtering Direct summary data.
Column
Type
Note
primary_key
string
The first column returned in a table of summary data. All data in the table is grouped by this primary key.
requests
integer
nonsuspect
integer
nonsuspect_rate
float
suspect
integer
suspect_rate
float
mobile
integer
mobile_rate
float
user_environment
integer
data_center
integer
ip_integrity
integer
web_crawler
integer
Summary Filter Operators
Operators are the comparison mechanism(s) used when filtering summary data. String values have a different set of operators than integers and floats, which are shown in the following table.
Column Type
Available Operators
Note
string
equals, not_equals, starts_with, ends_with, contains, not_contains
Can only be used with the primary_key column.
integer
equals, not_equals, greater_than, greater_than_equal_to, less_than, less_than_equal_to
Whole numbers only.
float
equals, not_equals, greater_than, greater_than_equal_to, less_than, less_than_equal_to
Maximum decimal precision of 2.
Summary Filter Conflicts
A summary data filter conflict can occur when a constraining column is unavailable for the requested endpoint. When a filter conflict occurs, the column will be ignored, and a conflict message will be returned in the query response data to make you aware that the constraint was not applied.
For example, performing a query to the Script: Pages endpoint using a summary filter that contains the requests column, which is not available on the Pages endpoint, will result in a filter conflict.
Script: Pages Filter Conflict - Query Response Data
"query": {
"start": 20261001,
"end": 20261007,
"instance": 123456789,
"source": false,
"campaign": false,
"host": false,
"path": false,
"filters": [
[
{
"column": "requests",
"operator": "greater_than_equal_to",
"value": 100,
"conflict": "Column%20not%20available"
},
{
"column": "responses",
"operator": "less_than_equal_to",
"value": 1000
},
{
"column": "good_rate",
"operator": "less_than",
"value": 76.54
}
]
],
"chart": true,
"rates": true,
"rules": true,
"search": false,
"startswith": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 1,
"pages": 1
}
Anura Reporting API - Interface Endpoints
The following Interface data endpoints are available in the current version of the Anura Reporting API.
Anura Reporting API - Interface Endpoints - Instances
The Interface: Instances endpoint will allow you to retrieve, or search, instances associated with your Reporting API token.
Method
URL
POST
https://api.anura.io/v1/interface/instances
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
Optional
Type
Description
Note
name
string
The name value to which results will be limited.
Results are returned based on a broad match of the declared value.
all
boolean
Set false to exclude the "All Instances" result object.
True by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"instances": [
{
"id": "All%20Instances",
"name": "All%20Instances"
"status": 1
},
{
"id": 1234567890,
"name": "yourInstanceName"
"status": 1
}
],
"query": {
"name": false,
"all": true,
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Interface Endpoints - Sources
The Interface: Sources endpoint will allow you to retrieve, or search, sources applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/interface/sources
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
instance
string
The ID of the instance to which results will be limited.
source
string
The source value to which results will be limited.
Results are returned based on a broad match of the declared value.
all
boolean
Set false to exclude the "All Sources" result.
True by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"sources": [
"All%20Sources",
"yourSourceTrackingId"
],
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"all": true,
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Interface Endpoints - Campaigns
The Interface: Campaigns endpoint will allow you to retrieve, or search, campaigns applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/interface/campaigns
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
Results are returned based on a broad match of the declared value.
all
boolean
Set false to exclude the "All Campaigns" result.
True by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"campaigns": [
"All%20Campaigns",
"yourCampaignTrackingId"
],
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"all": true,
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Script Endpoints
The following Script data reporting endpoints are available in the current version of the Anura Reporting API.
Anura Reporting API - Script Endpoints - Overview
The Script: Overview endpoint will allow you to retrieve total counts of data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/overview
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
Example Response
{
"total": {
"drops": 2,
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"chart": false
}
}
Anura Reporting API - Script Endpoints - Sessions
The Script: Sessions endpoint will allow you to retrieve a table of session specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/sessions
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"drops": 2,
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"Instance",
"Requests",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
"%7B%22id%22%3A%22All%20Instances%22%2C%22name%22%3A%22All%20Instances%22%7D",
25,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"%7B%22id%22%3A1234567890%2C%22name%22%3A%22yourInstanceName%22%7D",
25,
23,
10,
5,
8,
2,
1
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 1,
"pages": 1
}
}
Anura Reporting API - Script Endpoints - Browsers
The Script: Browsers endpoint will allow you to retrieve a table of web browser specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/browsers
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
browser
string
The browser to which results will be limited.
browser_version
string
The browser version to which results will be limited.
Applied only when the "browser" parameter is set.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"drops": 2,
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"Browser",
"Requests",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
false,
25,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"Chrome",
18,
17,
7,
4,
6,
2,
1
],
[
"Firefox",
7,
6,
3,
1,
2,
0,
0
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"browser": false,
"browser_version": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Script Endpoints - Operating Systems
The Script: Operating Systems endpoint will allow you to retrieve a table of operating system specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/operating-systems
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
string
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
os
string
The operating system to which results will be limited.
os_version
string
The operating system version to which results will be limited.
Applied only when the "os" parameter is set.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"drops": 2,
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"OS",
"Requests",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
false,
25,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"Windows",
23,
21,
8,
5,
8,
0,
1
],
[
"Android",
2,
2,
2,
0,
0,
2,
0
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"os": false,
"os_version": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Script Endpoints - Devices
The Script: Devices endpoint will allow you to retrieve a table of device specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/devices
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
manufacturer
string
The manufacturer to which results will be limited.
model
string
The model to which results will be limited.
Applied only when the "manufacturer" parameter is set.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"drops": 2,
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"Manufacturer",
"Requests",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
false,
25,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"%28non-identifiable%29",
23,
21,
8,
5,
8,
0,
1
],
[
"Samsung",
2,
2,
2,
0,
0,
2,
0
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"manufacturer": false,
"model": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Script Endpoints - Device Types
The Script: Device Types endpoint will allow you to retrieve a table of device type specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/device-types
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
type
string
The type to which results will be limited.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"drops": 2,
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"Type",
"Requests",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
false,
25,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"desktop",
23,
21,
8,
5,
8,
0,
1
],
[
"mobile:smart",
2,
2,
2,
0,
0,
2,
0
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"type": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Script Endpoints - Geography
The Script: Geography endpoint will allow you to retrieve a table of geographical specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/geography
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
country
string
The country to which results will be limited.
region
string
The region to which results will be limited.
Applied only when the "country" parameter is set.
city
string
The city to which results will be limited.
Applied only when the "country" and "region" parameters are set.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"drops": 2,
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"Country",
"Requests",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
false,
25,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"United%20States",
18,
17,
5,
4,
8,
2,
0
],
[
"Canada",
7,
6,
5,
1,
0,
0,
1
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"country": false,
"region": false,
"city": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Script Endpoints - Languages
The Script: Languages endpoint will allow you to retrieve a table of language specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/languages
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
language
string
The language to which results will be limited.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"Language",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
false,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"en-us",
17,
5,
4,
8,
2,
0
],
[
"en-ca",
6,
5,
1,
0,
0,
1
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"language": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Script Endpoints - Networks
The Script: Networks endpoint will allow you to retrieve a table of network specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/networks
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
network
string
The network to which results will be limited.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"drops": 2,
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"Network",
"Requests",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
false,
25,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"Comcast%20Cable%20Communications%20LLC",
18,
17,
5,
4,
8,
2,
0
],
[
"Rogers%20Communications%20Canada%20Inc.",
7,
6,
5,
1,
0,
0,
1
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"network": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Script Endpoints - Connections
The Script: Connections endpoint will allow you to retrieve a table of connection specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/connections
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
connection
string
The connection to which results will be limited.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"drops": 2,
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"Connection",
"Requests",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
false,
25,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"Cable%2FDSL",
23,
21,
8,
5,
8,
0,
1
],
[
"Cellular",
2,
2,
2,
0,
0,
2,
0
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"connection": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Script Endpoints - Pages
The Script: Pages endpoint will allow you to retrieve a table of page specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/pages
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
host
string
The host to which results will be limited.
path
string
The path to which results will be limited.
Applied only when the "host" parameter is set.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"Host",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
false,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"www.anura.io",
13,
7,
2,
4,
1,
1
],
[
"docs.anura.io",
10,
3,
3,
4,
1,
0
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"host": false,
"path": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Script Endpoints - Referrers
The Script: Referrers endpoint will allow you to retrieve a table of referrer specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/script/referrers
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
host
string
The host to which results will be limited.
path
string
The path to which results will be limited.
Applied only when the "host" parameter is set.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"good": 10,
"warning": 5,
"bad": 8,
"mobile": 2,
"adblocker": 1
},
"table": {
"headers": [
"Host",
"Responses",
"Good",
"Warning",
"Bad",
"Mobile",
"Ad%20Blocker"
],
"all": [
false,
23,
10,
5,
8,
2,
1
],
"rows": [
[
"%28direct%29",
14,
2,
3,
9,
1,
1
],
[
"www.google.com",
9,
8,
1,
0,
1,
0
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"host": false,
"path": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Direct Endpoints
The following Direct data reporting endpoints are available in the current version of the Anura Reporting API.
Anura Reporting API - Direct Endpoints - Overview
The Direct: Overview endpoint will allow you to retrieve total counts of data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/direct/overview
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
Example Response
{
"total": {
"nonsuspect": 17,
"suspect": 8,
"mobile": 2
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"chart": false
}
}
Anura Reporting API - Direct Endpoints - Sessions
The Direct: Sessions endpoint will allow you to retrieve a table of session specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/direct/sessions
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"nonsuspect": 17,
"suspect": 8,
"mobile": 2
},
"table": {
"headers": [
"Instance",
"Requests",
"Non-Suspect",
"Suspect",
"Mobile"
],
"all": [
"%7B%22id%22%3A%22All%20Instances%22%2C%22name%22%3A%22All%20Instances%22%7D",
25,
17,
8,
2
],
"rows": [
[
"%7B%22id%22%3A1234567890%2C%22name%22%3A%22yourInstanceName%22%7D",
25,
17,
8,
2
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 1,
"pages": 1
}
}
Anura Reporting API - Direct Endpoints - Browsers
The Direct: Browsers endpoint will allow you to retrieve a table of web browser specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/direct/browsers
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
string
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
browser
string
The browser to which results will be limited.
browser_version
string
The browser version to which results will be limited.
Applied only when the "browser" parameter is set.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"nonsuspect": 17,
"suspect": 8,
"mobile": 2
},
"table": {
"headers": [
"Browser",
"Requests",
"Non-Suspect",
"Suspect",
"Mobile"
],
"all": [
false,
25,
17,
8,
2
],
"rows": [
[
"Chrome",
18,
14,
4,
2
],
[
"Firefox",
7,
3,
4,
0
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"browser": false,
"browser_version": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Direct Endpoints - Operating Systems
The Direct: Operating Systems endpoint will allow you to retrieve a table of operating system specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/direct/operating-systems
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
os
string
The operating system to which results will be limited.
os_version
string
The operating system version to which results will be limited.
Applied only when the "os" parameter is set.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"nonsuspect": 17,
"suspect": 8,
"mobile": 2
},
"table": {
"headers": [
"OS",
"Requests",
"Non-Suspect",
"Suspect",
"Mobile"
],
"all": [
false,
25,
17,
8,
2
],
"rows": [
[
"Windows",
23,
15,
8,
0
],
[
"Android",
2,
2,
0,
2
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"os": false,
"os_version": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Direct Endpoints - Devices
The Direct: Devices endpoint will allow you to retrieve a table of device specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/direct/devices
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
manufacturer
string
The manufacturer to which results will be limited.
model
string
The model to which results will be limited.
Applied only when the "manufacturer" parameter is set.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"nonsuspect": 17,
"suspect": 8,
"mobile": 2
},
"table": {
"headers": [
"Manufacturer",
"Requests",
"Non-Suspect",
"Suspect",
"Mobile"
],
"all": [
false,
25,
17,
8,
2
],
"rows": [
[
"%28non-identifiable%29",
23,
15,
8,
0
],
[
"Samsung",
2,
2,
0,
2
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"manufacturer": false,
"model": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Direct Endpoints - Device Types
The Direct: Device Types endpoint will allow you to retrieve a table of device type specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/direct/device-types
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
type
string
The type to which results will be limited.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"nonsuspect": 17,
"suspect": 8,
"mobile": 2
},
"table": {
"headers": [
"Type",
"Requests",
"Non-Suspect",
"Suspect",
"Mobile"
],
"all": [
false,
25,
17,
8,
2
],
"rows": [
[
"desktop",
23,
15,
8,
0
],
[
"mobile:smart",
2,
2,
0,
2
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"type": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Direct Endpoints - Geography
The Direct: Geography endpoint will allow you to retrieve a table of geographical specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/direct/geography
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
country
string
The country to which results will be limited.
region
string
The region to which results will be limited.
Applied only when the "country" parameter is set.
city
string
The city to which results will be limited.
Applied only when the "country" and "region" parameters are set.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"nonsuspect": 17,
"suspect": 8,
"mobile": 2
},
"table": {
"headers": [
"Country",
"Requests",
"Non-Suspect",
"Suspect",
"Mobile"
],
"all": [
false,
25,
17,
8,
2
],
"rows": [
[
"United%20States",
16,
11,
5,
2
],
[
"Canada",
9,
6,
3,
0
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"country": false,
"region": false,
"city": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Direct Endpoints - Networks
The Direct: Networks endpoint will allow you to retrieve a table of network specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/direct/networks
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
network
string
The network to which results will be limited.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"nonsuspect": 17,
"suspect": 8,
"mobile": 2
},
"table": {
"headers": [
"Network",
"Requests",
"Non-Suspect",
"Suspect",
"Mobile"
],
"all": [
false,
25,
17,
8,
2
],
"rows": [
[
"Comcast%20Cable%20Communications%20LLC",
16,
11,
5,
2
],
[
"Rogers%20Communications%20Canada%20Inc.",
9,
6,
3,
0
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"network": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Direct Endpoints - Connections
The Direct: Connections endpoint will allow you to retrieve a table of connection specific data applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/direct/connections
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
start
integer
The starting date from which results will be returned.
Date format: YYYYMMDD
end
integer
The ending date to which results will be returned.
Date format: YYYYMMDD
Optional
Type
Description
Note
connection
string
The connection to which results will be limited.
instance
string
The ID of the instance to which results will be limited.
source
string
The source to which results will be limited.
campaign
string
The campaign value to which results will be limited.
chart
boolean
Set true to include a chartable daily breakdown.
False by default.
rates
boolean
Set true to include percentage rates.
False by default.
rules
boolean
Set true to include broken rule sets.
False by default.
filters
string, array
A pre-saved filter ID or "on the fly" array of filter groups containing filter objects.
Learn more about summary filters .
search
string
The first column value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "1:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
Example Response
{
"total": {
"nonsuspect": 17,
"suspect": 8,
"mobile": 2
},
"table": {
"headers": [
"Connection",
"Requests",
"Non-Suspect",
"Suspect",
"Mobile"
],
"all": [
false,
25,
17,
8,
2
],
"rows": [
[
"Cable%2FDSL",
23,
15,
8,
0
],
[
"Cellular",
2,
2,
0,
2
]
]
},
"query": {
"start": 20180101,
"end": 20180101,
"instance": false,
"source": false,
"campaign": false,
"connection": false,
"chart": false,
"rates": false,
"rules": false,
"filters": false,
"search": false,
"sort": "1:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1
}
}
Anura Reporting API - Raw Data Endpoints
The following Raw Data endpoints are available in the current version of the Anura Reporting API.
Anura Reporting API - Raw Data Endpoints - Table
The Raw Data: Table endpoint will allow you to retrieve, or search, a list of self-generated reports applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/raw/table
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
Optional
Type
Description
Note
search
string
A value to which results will be limited.
Results are returned based on a broad match of the declared value.
startswith
boolean
Set true to return only results starting with the search value.
False by default.
sort
string
The order in which results will be returned.
Up to 3 valid comma separated sortings may be requested. Format: column:asc or column:desc. "3:desc" is returned by default.
page
integer
The page of results to be returned.
Page 1 is returned by default.
limit
integer
The number of returned results.
20 results are returned by default. 1,000 results max.
processing_usage
boolean
Set true to return a detailed breakdown of account processing usage.
False by default. Admin users only.
Example Response
{
"processing": {
"limits": {
"minutes_total": 900,
"api_concurrent": 1,
"dashboard_concurrent": 2,
"minutes_available": 888
}
},
"table": {
"headers": [
"Name",
"Instance",
"Report%20Type",
"Requested",
"Status",
"Expires"
],
"rows": [
{
"id": "kuDZdF6v",
"name": "Anura%20Raw%20Response%20Report%2020220924",
"instance": "yourInstanceName",
"type": "Response",
"requested": "2022-09-24T13:22:31+00:00",
"created": null,
"failed": null,
"timed_out": null,
"cancelled": null,
"status": "In Progress",
"expires": "2022-10-25T00:00:00+00:00"
},
{
"id": "JpTxDnu4",
"name": "Anura%20Raw%20Request%20Report%2020220924",
"instance": "yourInstanceName",
"type": "Request",
"requested": "2022-09-24T13:16:19+00:00",
"created": "2022-09-24T13:17:28+00:00",
"failed": null,
"timed_out": null,
"cancelled": null,
"status": "Ready",
"expires": "2022-10-25T00:00:00+00:00"
}
]
},
"query": {
"search": false,
"sort": "3:desc",
"page": 1,
"limit": 20,
"results": 2,
"pages": 1,
"processing_usage": true
}
}
Anura Reporting API - Raw Data Endpoints - Report
The Raw Data: Report endpoint will allow you to retrieve detailed, report specific information applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/raw/report
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
raw
string
The ID of the Raw Data report being requested.
Example Response
{
"id": "kuDZdF6v",
"type": "Response",
"name": "Anura%20Raw%20Response%20Report%2020220924",
"start": 20220918,
"end": 20220924,
"instance_id": 1234567890,
"instance_name": "yourInstanceName",
"columns": {
"standard": [
"source",
"campaign",
"response_id",
"result",
"remote_address",
"network",
"country",
"region",
"city",
"user_agent",
"browser_name",
"browser_version",
"os_name",
"os_version",
"device_type"
],
"additional": null
},
"filters": null,
"send_email": true,
"requested": "2022-09-24T13:22:31+00:00",
"file_name": "anura-response-yourInstanceName-20220918-20220924-1664025751-f84312.zip",
"file_size": 208472,
"rows": 5721,
"created": "2022-09-24T13:31:46+00:00",
"failed": null,
"timed_out": null,
"cancelled": null,
"alerted": "2022-09-24T13:31:46+00:00",
"status": "Ready",
"processing_minutes": 10,
"expires": "2022-10-25T00:00:00+00:00"
}
Anura Reporting API - Raw Data Endpoints - Request
The Raw Data: Request endpoint will allow you to generate a new report applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/raw/request
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
type
string
The type of Raw Data report being requested.
Acceptable values: request, response, direct.
instance
string
The ID of the instance for which Raw Data will be returned.
start
integer
The starting date from which Raw Data will be returned.
Date format: YYYYMMDD. No more than 90 days old.
end
integer
The ending date to which Raw Data will be returned.
Date format: YYYYMMDD. Not greater than today.
standard
array
An array of Standard Data columns to be returned.
At least one Standard Data column is required. See the table below for acceptable columns.
Optional
Type
Description
Note
name
string
A descriptive name, or title, for your report.
A report name is generated automatically when no value is submitted.
additional
array
An array of Additional Data columns to be returned.
Referenced by number. An array of [1, 3, 5] should be submitted for Additional Data columns 1, 3, and 5 respectively.
filters
array
An array of objects, consisting of a column, operator, and value, that are used to narrow results when generating reports.
Standard and Additional data columns must be present to be filtered. See below for more information regarding filter objects and operators.
send_email
boolean
Send an email alert when your Raw Data report has finished generating.
True by default.
Limitations
Please be aware of the following processing limitations when requesting Raw Data reports:
Accounts are limited to 360 total minutes of data processing per day - across all users.
Users may request up to two concurrent reports at a time via the Anura Dashboard interface.
Users may only request one report at a time via the Anura API.
Processing time is rounded up to the minute.
Data processing limitations are default values and can be modified. Talk to support if you're encountering issues with the default limitations.
Standard Data Columns
Report Type
Acceptable Columns
request
source
campaign
exid
remote_address
network
connection
country
region
city
user_agent
browser_name
browser_version
os_name
os_version
device_type
device_manufacturer
device_model
mobile
location
response
source
campaign
response_id
result
rule_sets
invalid_traffic_type
remote_address
network
connection
country
region
city
language
user_agent
browser_name
browser_version
os_name
os_version
device_type
device_manufacturer
device_model
mobile
ad_blocker
page
referrer
direct
source
campaign
result
rule_sets
invalid_traffic_type
remote_address
network
connection
country
region
city
user_agent
device_type
browser_name
browser_version
os_name
os_version
device_manufacturer
device_model
mobile
app_id
device_id
requesting_remote_address
requesting_user_agent
Filter Objects
A filter is an object consisting of a column, operator, and value, that is used to narrow the number of results in a report. Multiple filters may be applied to a request; however, a column may only be filtered once.
Example Filters Array
"filters": [
{
"column": "source",
"operator": "conatins",
"value": "hello"
}
]
The above example illustrates a filter object on the source column where the value contains "hello".
Filter Operators
Operators are the comparison mechanism used when narrowing report results. Most operators can be used against any column, however, there are a few special cases to be aware of. Available operators and their special cases can be found in the following tables.
Column Type
Column
Available Operators
Note
Standard Data
All standard data columns except for special cases, listed below.
equals, not_equals, starts_with, ends_with, contains, not_contains
Additional Data
Numeric value (1-10 default)
equals, not_equals, starts_with, ends_with, contains, not_contains, empty, not_empty
Value is not applied when using empty and not_empty operators.
Special Case Operators
Report Type
Column
Available Operators
Note
request
result
None Available
Acceptable values: "with-responses" and "drops".
response
result
equals, not_equals
Acceptable values: "good", "warning", and "bad".
direct
result
equals, not_equals
Acceptable values: "non-suspect" and "suspect".
request
exid
equals, not_equals, starts_with, ends_with, contains, not_contains, empty, not_empty
Value is not applied when using empty and not_empty operators.
direct
app_id
equals, not_equals, starts_with, ends_with, contains, not_contains, empty, not_empty
Value is not applied when using empty and not_empty operators.
direct
device_id
equals, not_equals, starts_with, ends_with, contains, not_contains, empty, not_empty
Value is not applied when using empty and not_empty operators.
Example Request
{
"token": "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzUxMiJ9.eyJpc3MiOiIxMjMiLCJpYXQiOjE2NjE5OTIwODAsImp0aSI6ImlPYVNOQW10UmhZU3l2MXQ5eDkiLCJhdWQiOiIwbVglMkZSJTJCTWdBS2xteSIsInRrbiI6ImFwaSJ9.SC8PtaQetBwGBu56J0yyUtqVEL",
"type": "response",
"instance": 1234567890,
"start": 20220918,
"end": 20220924,
"standard": [
"source",
"campaign",
"response_id",
"result",
"remote_address",
"network",
"country",
"region",
"city",
"user_agent",
"browser_name",
"browser_version",
"os_name",
"os_version",
"device_type"
],
"name": "My%20First%20Raw%20Data%20Report",
"additional": [
1,
3,
5
],
"filters": [
{
"column": "source",
"operator": "contains",
"value": "hello"
},
{
"column": "campaign",
"operator": "contains",
"value": "world"
}
],
"send_email": false
}
Example Response
{
"success": true,
"message": "Your%20raw%20data%20report%20has%20been%20requested",
"feedback": {
"pass": {},
"fail": {}
},
"id": "mnUeFVP0"
}
Anura Reporting API - Raw Data Endpoints - Cancel
The Raw Data: Cancel endpoint will allow you to cancel "In Progress" report requests applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/raw/cancel
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
raw
string
The ID of the Raw Data report to cancel.
Example Response
{
"success": true,
"message": "Your%20raw%20data%20report%20request%20has%20been%20cancelled",
"feedback": {
"pass": {},
"fail": {}
}
}
Anura Reporting API - Raw Data Endpoints - Download
The Raw Data: Download endpoint returns a temporary URL that will allow you to download a self-generated report applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/raw/download
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
raw
string
The ID of the Raw Data report to download.
Example Response
{
"url": "https%3A%2F%2Fanura-reports.s3.amazonaws.com%2Fraw%2F1234567890%2Fresponse%2Fanura-response-yourInstanceName-20220918-20220924-1664025751-f84312.zip"
}
Anura Reporting API - Raw Data Endpoints - Remove
The Raw Data: Remove endpoint will allow you to remove self-generated reports applicable to the supplied POST parameters.
Method
URL
POST
https://api.anura.io/v1/raw/remove
Parameters
Required
Type
Description
Note
token
string
The token string you have been issued to connect to the Anura Reporting API.
raw
string
The ID of the Raw Data report to remove.
An array of report ID strings may also be submitted.
Example Response
{
"success": true,
"message": "%22Anura%20Raw%20Direct%20Report%2020220924%22%20has%20been%20removed",
"feedback": {
"pass": {},
"fail": {}
}
}